#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define CREATIONCLEFSPUBLIQUEPRIVEE_H_ 
#include "CreationClefsPubliquePrivee.h"

extern int saisirEntier(char * affichage, FILE *f);//SaisirTexte_Entier.c
extern int* menuCreationSuiteSuperCroissante(int taille,int *N,int *Z);//MenuCryptage.c


CLEFPRIVEE * creerClefPrivee(int taille){
	CLEFPRIVEE *clefprivee=(CLEFPRIVEE*)malloc(sizeof(CLEFPRIVEE));
	
	clefprivee->tailleSuite=taille;
	
	clefprivee->suiteSuperCroissante=menuCreationSuiteSuperCroissante(taille,&clefprivee->N,&clefprivee->Z);
	
/*	int i;
	for(i=0;i<taille;i++){
		printf("valeur 1 = %d\n",*(clefprivee->suiteSuperCroissante+i));
	}
*/	 
	
	clefprivee->permutation=permuter(taille);
	
	return clefprivee;
}

CLEFPUBLIQUE * creerClefPublique(CLEFPRIVEE *clefprivee){
	CLEFPUBLIQUE *clefpublique=(CLEFPUBLIQUE*)malloc(sizeof(CLEFPUBLIQUE));
	int i;
	int aux;
	
	clefpublique->tailleSuite=clefprivee->tailleSuite;
	
	clefpublique->suitePermuteeNonSuperCroissante=(int*)malloc(clefprivee->tailleSuite*sizeof(int));
	
	
	for(i=0;i<clefprivee->tailleSuite;i++){
		*(clefpublique->suitePermuteeNonSuperCroissante + *(clefprivee->permutation+i) )=0;
	}
	for(i=0;i<clefprivee->tailleSuite;i++){
		aux=(*(clefprivee->suiteSuperCroissante+i)*clefprivee->Z)%clefprivee->N;		
		*(clefpublique->suitePermuteeNonSuperCroissante+ *(clefprivee->permutation+i) )=aux;
	}

/*	for(i=0;i<clefpublique->tailleSuite;i++){
		printf("valeur %d = %d\n",i,*(clefpublique->suitePermuteeNonSuperCroissante+i));
	}*/
	
	return clefpublique;
}

int * saisieSuiteSupercroissante(int taille,int *N,int *Z){
	int i,aux,somme=0;
	int * superCroissante=(int*)malloc(taille*sizeof(int));
	for(i=0;i<taille;i++){
		printf("Entrez la valeur n°%d de la suite supercroissante\n",i+1);
		do{
			aux=saisirEntier("",stdin);
			if(aux<=somme)printf("Il y a erreur!! Le nouvel élément doit être supérieur strict. à %d\n",somme);
		}while(aux<=somme);
		*(superCroissante+i)=aux;
		somme+=aux;
	}
	printf("Entrez un entier supérieur à %d\n",somme);
	do{
		*N=saisirEntier("",stdin);
		if(*N<=somme)printf("Erreur de saisie!!Recommencez!\n(SUPERIEUR STRICT. A %d)",somme);
	}while(*N<=somme);
	printf("Entrez un entier inférieur à %d\n",*N);
	do{
		*Z=saisirEntier("",stdin);
		if(*Z>=*N)printf("Erreur de saisie!!Recommencez!\n(INFERIEUR STRICT. A %d)",*N);
	}while(*Z>=*N);
	return(superCroissante);
}

int * creationAutomatiqueSuiteSuperCroissante(int taille,int *N,int *Z){
	int i,aux=1;
	int *superCroissante=(int*)malloc(taille*sizeof(int));
	for(i=0;i<taille;i++){
		*(superCroissante+i)=aux;
		aux*=2;
	}
	*N=aux;
	*Z=3;
	return(superCroissante);
}

int* permuter(int taille){
	int i,j,aux;
	int *suitePermutee=(int*)malloc(taille*sizeof(int));
	for(i=0;i<taille;i++) *(suitePermutee+i)=-1;
	i=0;
	while(i<taille){
		j=0;
		aux=rand()%taille;
		while( (j<i)&&( aux!=*(suitePermutee+j) ) ){
			j++;
		}
		if(j==i){
			*(suitePermutee+i)=aux;
			i++;
		}
	}
	return suitePermutee;
}


int compression(char* *texte_A_Crypter){
	int longueurTexte=strlen(*texte_A_Crypter);
	int i,reste=1,tab[]={8,9,10,11,12,13};
	do{
		i=0;
		while(reste!=0 && i<6){
			reste=longueurTexte%tab[i];
			i++;
		}
		if(reste!=0){
			char *chaine=(char*)malloc((longueurTexte+2)*sizeof(char));
			strcpy(chaine,*texte_A_Crypter);
			*(chaine+longueurTexte)=' ';
			*(chaine+longueurTexte+1)='\0';
			free(*texte_A_Crypter);
			*texte_A_Crypter=chaine;
			longueurTexte=strlen(*texte_A_Crypter);			
		}
	}while(reste!=0);
	return(tab[i-1]);
}

int depression(char* *texte_A_Crypter){
	int longueurTexte=strlen(*texte_A_Crypter);
	int i,reste=1,tab[]={2,3,4,5,6};
	do{
		i=0;
		while(reste!=0 && i<5){
			reste=longueurTexte%tab[i];
			i++;
		}
		if(reste!=0){
			char *chaine=(char*)malloc((longueurTexte+2)*sizeof(char));
			strcpy(chaine,*texte_A_Crypter);
			*(chaine+longueurTexte)=' ';
			*(chaine+longueurTexte+1)='\0';
			free(*texte_A_Crypter);
			*texte_A_Crypter=chaine;
			longueurTexte=strlen(*texte_A_Crypter);			
		}
	}while(reste!=0);
	return(tab[i-1]);
}
