#include <stdio.h>

void algorithmeEuclideEtendu(int a,int b,int *u,int *v){
	int u1,v1,quotient;
	if(b==0){
		*u=1;
		*v=0;
	}
	else{
		quotient=a/b; /*on met cette affectation ici car on ne peut la faire lorsque b=0*/
		algorithmeEuclideEtendu(b,a%b,&u1,&v1);
		*u=v1;
		*v=u1-v1*quotient;
	}
}
/*  Explications!!
   
   PGCD(A,B)= (U x A)+(V x B)  avec U et V  2 entiers relatifs et A et B 2 entiers quelconques! 
   De la même façon on obtient en prenant à la place de A --> B
                                                        B --> A%B (A mod B)
   PGCD(B,A%B)= (U' x B) + (V' x A%B) 
   
   Mais d'après l'algo. d'Euclide  A= (A/B x B)+ A%B   où A/B = quotient de la division entiere
                                                                de A par B
   d'où A%B = A - (A/B x B)                            où A%B = reste de la div. entiere de
                                                                A par B
   
   (U' x B) + (V' x A%B) = (U' x B) + ( V' x [ A - (A/B x B)] )
                         = (V' x A) + ( U' - [V' x A/B] )xB
                         
   or PGCD(A,B)=PGCD(B,A%B) (hypothese de l'algo. d'Euclide)
                                                                  
   On a alors (U x A)+(V x B) = (V' x A) + ( U' - [V' x A/B] )xB
   Donc en prenant U = V' et V = (U' - [V' x A/B]) on obtient au final ce que l'on souhaite
   grâce à la récursivité!!
   ( ie on aura trouvé U et V tels que   (A x U) + (B x V) = PGCD(A,B)  )
   
   et dans ce cas là V est l'inverse modulo A de B ^_^
   
*/     

int inverseModuloN( int N, int nbr_a_inverser ){
	int inverseModulo,u;
	algorithmeEuclideEtendu(N,nbr_a_inverser,&u,&inverseModulo);
	if(inverseModulo<0)inverseModulo+=N;
	return(inverseModulo);
}

int passageValeurCrypValeurInversMod(int valeurCryp,int inverseZModuloN,int N){
	int aux;
	aux=(valeurCryp*inverseZModuloN)%N;
	return(aux);	
}

/*
int main(){
	int N=23,Z=13,A=inverseModuloN(N,Z);
	printf("On va faire un petit test de cet algo.\n");
	printf("L'inverse modulo %d de %d est %d\n",N,Z,(A>=0)?A:(A+N));
	return 1;
}*/	
/*On rajoute N a l'inverseModulo que l'on trouve si celui ci est négatif.
Tout cela car les divers poids des objets du sac à dos sont positifs!!*/
