#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "intToCarac.h"
#include "ChargerFichier.h"
#include "SauvegarderFichier.h"
#include "SaisirTexte.h"
#include "CreerClePrivee.h"
#include "permutation.h"
#include "PassageValeurTabBinaire.h"
#include "EuclideEtendu.h"
extern int changementTAILLE_SUITE(char * texte);
extern void permutationBool(BOOLEEN tabBool[], int suitePermutee[],BOOLEEN *b,int);


int main(){
	char *texte=saisirTexte("Entrez la chaine à crypter");
	int nouvelleTaille=changementTAILLE_SUITE(texte);
	printf("nouvelle TAILLE %d\n",nouvelleTaille);
	int suiteSuperCroissante[nouvelleTaille*7],suitePermutee[nouvelleTaille*7],clePublique[nouvelleTaille*7],N,Z;
	int i,longueur_texte=strlen(texte),aux[longueur_texte];
	
	int Q,aux1,aux2;
	BOOLEEN *booleen;
	BOOLEEN *tabBool;
	
	
	creerClePrivee(suiteSuperCroissante,&N,&Z,nouvelleTaille*7);
	
	Q=inverseModuloN(N,Z);
	
	printf("inverse modulo = %d\n",Q);
	
	permutation(suitePermutee,nouvelleTaille*7);
	
	for(i=0;i<nouvelleTaille*7;i++) clePublique[i]=(suiteSuperCroissante[ suitePermutee[i] ]*Z)%N;
	
	printf("Voici le texte crypté\n");
	
	//
	i=0;
	int compteur,z,j=0;
	
	tabBool=(BOOLEEN*)malloc((7*nouvelleTaille)*sizeof(BOOLEEN));
	booleen=(BOOLEEN*)malloc((7*nouvelleTaille)*sizeof(BOOLEEN));
	
	while(i<longueur_texte){
		booleen=passerValeurTabBinaire(*(texte+i));
		for(z=0;z<nouvelleTaille;z++){
			for(compteur=0;compteur<7;compteur++) *(tabBool+(z*7)+compteur)=*(booleen+compteur);
			i++;
		}
		aux[j]=passerTabBinaireValeurCryptee( tabBool , clePublique,N,nouvelleTaille*7);
		printf("\t\t%d",aux[j]);
		j++;
	}
	free(tabBool);
	//
	
	printf("\nNous allons maintenant sauvegarder ce texte\n");
	saveFichierCrypte(aux,longueur_texte/nouvelleTaille);
	free(texte);
	
	printf("Nous allons maintenant charger le texte et le decrypter\n");
	
	int tailleLoadMess,*CryptMess;
	
	CryptMess=chargerFichierCrypt(&tailleLoadMess);
	
	
	printf("Nous allons maintenant décrypter ce texte!!\n");
	tabBool=(BOOLEEN*)malloc((nouvelleTaille*7)*sizeof(BOOLEEN));
	for(i=0;i<tailleLoadMess;i++){
		aux2=*(CryptMess+i)*Q%N;
		booleen=passerValeurTabBinaireDecryp(aux2,suiteSuperCroissante,nouvelleTaille*7);
		permutationBool(tabBool,suitePermutee,booleen,nouvelleTaille*7);
		free(booleen);
		
		//
		booleen=(BOOLEEN*)malloc(7*sizeof(BOOLEEN));
		
		for(z=0;z<nouvelleTaille;z++){
			for(compteur=0;compteur<7;compteur++) booleen[compteur]=tabBool[(z*7)+compteur];
			aux1=passerTabBinaireValeur(booleen);
			printf("%c",aux1);
		}
		free(booleen);
		//
	}
	
	return 1;
}

